"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const merge_1 = require("./merge");
const shallowMerge_1 = require("./shallowMerge");
exports.mergeDeep = mergeDeepFactory(merge_1.merge);
exports.shallowMergeDeep = mergeDeepFactory(shallowMerge_1.shallowMerge);
function mergeDeepFactory(mrg) {
    let mrgDeep;
    mrgDeep = (a, b) => {
        let r = a;
        for (const p in b) {
            if (b.hasOwnProperty(p)) {
                const v = (typeof b[p] === "object" && !Array.isArray(b[p])) ? mrgDeep(a.hasOwnProperty(p) ? a[p] : {}, b[p], mrg) : b[p];
                r = mrg(r, { [p]: v });
            }
        }
        return r;
    };
    return mrgDeep;
}
